import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:verttice_logic/verttice_logic.dart';

class VertticeUIConfig {
  VertticeUIConfig._privateConstructor();

  late Future<List<String>> Function({
    required String optionsID,
  }) _getExpanedFormOptions;
  late Future<List<String>> Function({
    required String optionsID,
    required String option,
  }) _setExpanedFormNewOption;

  late Future<List<FileModel>> Function({
    required List<UploadFileDataModel> files,
  }) _upalodFiles;

  late Future<String> Function({
    required String path,
  }) _getStorageDownloadURL;

  late Future<Uint8List> Function({
    required String path,
  }) _getStorageData;

  late String _firebaseApiKey;

  late Widget _signInPage;

  Future<List<String>> Function({
    required String optionsID,
  }) get getExpanedFormOptions => _getExpanedFormOptions;

  Future<List<String>> Function({
    required String optionsID,
    required String option,
  }) get setExpanedFormNewOption => _setExpanedFormNewOption;

  Future<List<FileModel>> Function({
    required List<UploadFileDataModel> files,
  }) get upalodFiles => _upalodFiles;

  Future<String?> Function({
    required String path,
  }) get getStorageDownloadURL => _getStorageDownloadURL;

  Future<Uint8List?> Function({
    required String path,
  }) get getStorageData => _getStorageData;

  String get firebaseApiKey => _firebaseApiKey;

  Widget get signInPage => _signInPage;

  init({
    required Future<List<String>> Function({
      required String optionsID,
    })
        getExpanedFormOptions,
    required Future<List<String>> Function({
      required String optionsID,
      required String option,
    })
        setExpanedFormNewOption,
    required Future<List<FileModel>> Function({
      required List<UploadFileDataModel> files,
    })
        upalodFiles,
    required Future<String> Function({
      required String path,
    })
        getStorageDownloadURL,
    required Future<Uint8List> Function({
      required String path,
    })
        getStorageData,
    required String firebaseApiKey,
    required Widget signInPage,
  }) {
    _getExpanedFormOptions = getExpanedFormOptions;
    _setExpanedFormNewOption = setExpanedFormNewOption;
    _upalodFiles = upalodFiles;
    _getStorageDownloadURL = getStorageDownloadURL;
    _getStorageData = getStorageData;
    _firebaseApiKey = firebaseApiKey;
    _signInPage = signInPage;
  }

  static final VertticeUIConfig instance =
      VertticeUIConfig._privateConstructor();
}
