import "package:flutter/material.dart";
import 'package:verttice_logic/verttice_logic.dart';
import 'package:verttice_ui/src/base_config.dart';

class ScreenSizeUtils {
  ScreenSizeUtils._();

  static bool isMobile({
    required BuildContext context,
  }) {
    final width = MediaQuery.of(context).size.width;
    final height = MediaQuery.of(context).size.height;

    return width <= mobileWidth || height <= mobileHeight;
  }

  static ScreenType screenType(
    BuildContext context,
  ) {
    final width = MediaQuery.of(context).size.width;
    final height = MediaQuery.of(context).size.height;

    if (width <= mobileWidth || height <= mobileHeight) {
      return ScreenType.mobile;
    }
    return ScreenType.desktop;
  }
}
